# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EdgeGateway::Mgmt::V2019_03_01
  module Models
    #
    # The security settings of a device.
    #
    class SecuritySettings < ARMBaseModel

      include MsRestAzure

      # @return [AsymmetricEncryptedSecret] Device administrator password as an
      # encrypted string (encrypted using RSA PKCS #1) is used to sign into the
      # local web UI of the device. The Actual password should have at least 8
      # characters that are a combination of  uppercase, lowercase, numeric,
      # and special characters.
      attr_accessor :device_admin_password


      #
      # Mapper for SecuritySettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SecuritySettings',
          type: {
            name: 'Composite',
            class_name: 'SecuritySettings',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              device_admin_password: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.deviceAdminPassword',
                type: {
                  name: 'Composite',
                  class_name: 'AsymmetricEncryptedSecret'
                }
              }
            }
          }
        }
      end
    end
  end
end
